!------------This program calculates the grain areas and 
!------------perimeters and other topological features of a grain.
	subroutine	topology(mcstep,lname,numgr)
	include 'comblock.f'
	dimension nos(ni*nj*2),nogr(ni*nj*2)
	integer grain(ni,nj)
	character*60 filenames,filetemp
	logical (4) resul,resul1,resul2
!	grain(ni,nj) is the index of a grain for each grid point
	imax=compdat(1)
	jmax=compdat(2)
	kmax=compdat(3)
	iqmax=compdat(4)
	imcmax=compdat(5)
	nneig=compdat(6)
	open(lname+30,file=filenames(lname))
	open(12,file = filenames(4))
	open(27,file = "c:\MC\temp\Indexout.dat")
!	Ngrain is the counter for number of grains
!	deltax and deltay are the grid spacings
	deltaX=1
	deltaY=1
!***************************************
	read(lname+30,*)
	read(lname+30,*)
!	if(mcstep.eq.1) read(lname+30,*)
!	read in the orientations
	do i = 1,imax
	do j = 1,jmax
	read(lname+30,*)ii,jj,kk,niq(i,j)
	grain(i,j)=0
	enddo
	enddo
	
	do ml=1,ni*nj
	nogr(ml)=0
	enddo
!	First we give an index to each grain. Let us call the 
!	indexing variable as grain(i,j). The first grain is
!	given an index of 1. 
 
	Ngrain=1
	grain(1,1)=1
	do 200 i = 1,imax
	do 100 j = 1,jmax
	j1 = j-1
	i1= i-1
!	First the grids on the domain borders are considered.
!	If a new orientation is encountered the count is increased otherwise
!	the orientation of earlier grain is taken.
	if(j1.eq.0.and.i1.eq.0) goto 100
!	along the 'i=1' line
	if(j1.eq.0.and.i1.ne.0) then
	if (niq(i1,j).ne.niq(i,j)) then
	Ngrainold=Ngrain
	Ngrain=Ngrain+1
	grain(i,j)=Ngrain
	else
	grain(i,j)=grain(i1,j)
	endif
	Ngrainold=Ngrain
	goto 100
	endif

!	along the 'j=1' line
	if(j1.ne.0.and.i1.eq.0) then
	if (niq(i,j1).ne.niq(i,j)) then
	Ngrainold=Ngrain
	Ngrain=Ngrain+1
	grain(i,j)=Ngrain
	else
	grain(i,j)=grain(i,j1)
	endif
	Ngrainold=Ngrain
	goto 100
	endif

!*********************************************************
!	Procedure for the interior grids.
	if (niq(i,j1).ne.niq(i,j)) then
	Ngrainold=Ngrain
	Ngrain=Ngrain+1
	grain(i,j)=Ngrain
	if (niq(i1,j).eq.niq(i,j)) then
	grain(i,j)=min0(grain(i,j),grain(i1,j))
	grain(i1,j)=min0(grain(i,j),grain(i1,j))
	Ngrain = Ngrainold
	endif
	endif
!************************************************************
!	If the same orientation as that at the north of the grid point is encountered in
!	an interior grid, then the orientation of the grid to the west is checked.
!	If the orientation is found same it is changed to that of the west grid.
	if (niq(i,j1).eq.niq(i,j)) then
	grain(i,j)=grain(i,j1)
	if (niq(i1,j).eq.niq(i,j)) then
	grain(i,j)=min0(grain(i,j),grain(i1,j),grain(i,j1))
	grain(i1,j)=min0(grain(i,j),grain(i1,j),grain(i,j1))
	grain(i,j1)=min0(grain(i,j),grain(i1,j),grain(i,j1))
	Ngrain=Ngrainold
	endif		
	endif
100	continue
200	continue

!	Sometimes a single grain is indexed as two different grains.
!	Correct that anamoly by checking the orientations of all the neighbors 	
	do 111 j =1,jmax
	do 222 i = 1,imax
	do 22 li = -1,1
	do 22 lj = -1,1
	if (li.eq.0.and.lj.eq.0) goto 22
	j2 = j+lj
	i2= i+li
	if (j2.eq.0.or.i2.eq.0) goto 22
	if (j2.gt.jmax.or.i2.gt.imax) goto 22
	if (niq(i,j).eq.niq(i2,j2)) then
	grain(i2,j2)=min0(grain(i2,j2),grain(i,j))
	grain(i,j)=min0(grain(i2,j2),grain(i,j))
	endif
22	continue
!	Grain(i,j) is now the grid location with the minimum orienation
!	Make all the neighboring orientations equal to that of grain(i,j)
	do 23 li = -1,1
	do 23 lj = -1,1
	if (li.eq.0.and.lj.eq.0) goto 23
	j2 = j+lj
	i2= i+li
	if (j2.eq.0.or.i2.eq.0) goto 23
	if (j2.gt.jmax.or.i2.gt.imax) goto 23
	if (niq(i,j).eq.niq(i2,j2)) then
	grain(i2,j2)=grain(i,j)
	endif
23	continue
222	continue
111	continue
!******************************************************************
!	To correct for any anomalies a check is made backwards
!	in the j direction and the index for the grid is changed 
!	if found different from the neigbors (orientations
!	being similar).
	do 115 i =1,imax
	do 225 j = jmax,1,-1
	do 25 li = -1,1
	do 25 lj = -1,1
	if (li.eq.0.and.lj.eq.0) goto 25
	j3 = j+lj
	i3= i+li
	if (j3.eq.0.or.i3.eq.0) goto 25
	if (j3.gt.jmax.or.i3.gt.imax) goto 25
	if (niq(i,j).eq.niq(i3,j3)) then
	grain(i3,j3)=min0(grain(i3,j3),grain(i,j))
	grain(i,j)=min0(grain(i3,j3),grain(i,j))
	endif
25	continue
	do 26 li = -1,1
	do 26 lj = -1,1
	if (li.eq.0.and.lj.eq.0) goto 26
	j3 = j+lj
	i3= i+li
	if (j3.eq.0.or.i3.eq.0) goto 26
	if (j3.gt.jmax.or.i3.gt.imax) goto 26
	if (niq(i,j).eq.niq(i3,j3)) then
	grain(i3,j3)=grain(i,j)
	endif
26	continue
225	continue
115	continue


!********************************************************
!	The indexing of each grain doesnt follow a serial order
!	because all the corrections to the grain index are done after
!	the counter Ngrain stops. Correct that in the following part of the code.
	call grindexmax(numgr,grain)
	do i =1,imax
	do j=1,jmax
	nogr(grain(i,j))=grain(i,j)
	enddo
	enddo
!********************************************************
	do l=1,numgr
	if(nogr(l).eq.0) then
	loop:do n=1,numgr
	if(nogr(l+n).ne.0)exit loop
	enddo loop
	do i =1,imax
	do j=1,jmax
	if(grain(i,j).eq.l+n)grain(i,j)=l
	enddo
	enddo
	nogr(l)=l
	nogr(l+n)=0
	endif
	enddo
!************************************************************
	if (mcstep.eq.1) then
	  write(12,*)'TITLE="Orientations and grid indexes"'
        write(12,*)'VARIABLES="I","J","IQ","INDX"'
        endif
        write(12,*)'Zone I=',jmax,',J=',imax,',F=POINT'
	do i = 1,imax
	do j =1,jmax
	write(12,*) i,j,niq(i,j),grain(i,j)
	enddo
	enddo
	if (mcstep.eq.imcmax) then
	jn=jmax/25
	write(27,*) 'Index output file written for printing'
	do In=1,imax
	do mj=1,Jn
	write(27,*)
	mv=25*(mj-1)+1
	write(27,3) (In,i=1,25)
	write(27,4) (j,j=mv,25*mj)
	write(27,7) (niq(In,j),j=mv,25*mj)
	write(27,8) (grain(In,j),j=mv,25*mj)
	enddo
	enddo
	endif
3	format ('I=         ',25I3)
4	format ('J=         ',25I3)
7	format ('niq(i,j)=   ',25I3)
8	format ('Grain(i,j)=',25I3)
	call grindexmax(numgr,grain)
	write(*,*)mcstep, numgr
!	call perimeter(grain,numgr,deltax,deltay,mcstep)
	call pntsingrn(grain,numgr,mcstep)
	call numsides(numgr,mcstep,grain,ncor)
	call rbyrbar(grain,numgr,mcstep)
	call lensides(numgr,ncor)
	close(lname+30)
	end
!*************************************************************
!	NEW SUBROUTINE
!*************************************************************
!	This subroutine is used to find the maximum grain index
!	and thus determines the number of grains.
	subroutine grindexmax(numgr,grain)
	include 'comblock.f'
	integer grain(ni,nj)
	numgr =0
	do i =1,imax
	do j =1,jmax
	numgr=max0(numgr,grain(i,j))
	enddo
	enddo
	end subroutine

c***************************************************************
	subroutine pntsingrn(grain,numgr,mcstep)
	include 'comblock.f'
      integer grain(ni,nj),ngrn(ni*nj*2),tempor(ni,nj)
	integer ngr(ni*nj*2),visit(ni,nj)
	dimension nx(ni*nj*2),ny(ni*nj*2),nt(ni*nj*2)
	character*60 filenames
	open(14,file="c:\MC\temp\boundgrns.dat")
	open(15,file="c:\MC\temp\grnnum.dat")
	open(17,file="c:\MC\temp\nogrns.dat")
	do i =1,imax
	do j =1,jmax
	tempor(i,j)=0
	enddo
	enddo
	do i =1,imax
	do j =1,jmax
	do 26 li = -1,1
	do 26 lj = -1,1
	if (li.eq.0.and.lj.eq.0) goto 26
	j5 = j+lj
	i5= i+li
	if (j5.eq.0.or.i5.eq.0) goto 26
	if (j5.gt.jmax.or.i5.gt.imax) goto 26
	if (grain(i,j).ne.grain(i5,j5)) then
	tempor(i,j)=grain(i,j)
	goto 110
	endif
26	continue
110	enddo
	enddo
	do i =1,imax
	do j =1,jmax
	if(i.eq.1.or.i.eq.imax)	tempor(i,j)=grain(i,j)
	if(j.eq.1.or.j.eq.imax)	tempor(i,j)=grain(i,j)
	enddo
	enddo
c	Initialization
	do l =1,ni*nj*2
	ngrn(l)=0
	nt(l)=0
	ngr(l)=0
	enddo
	do i =1,ni*nj*2
	nx(i)=0
	ny(i)=0
	enddo
c******************************************************************
	do l =1,numgr

	 do i =1,imax
	  do j =1,jmax
	  
	  if (l.eq.tempor(i,j)) then
	 
	  ngrn(l)=ngrn(l)+1
	    write(14,*)l,i,j
	  endif
	  enddo
	 enddo
	enddo
c*****************************************************************
c	The grids that define the grain boundary are written in a anti
c	clockwise manner.
	
	rewind(14)
	do l =1,numgr
	 do i= 1,ngrn(l)
	 read(14,*)ll,nx(i),ny(i)
	 visit(nx(i),ny(i))=2
	 enddo
      	j=1
	    write(15,*)l,nx(j),ny(j)
		nt(l)=nt(l)+1
	   visit(nx(j),ny(j))=1
	 do nk=1,ngrn(l)
        do i =1, ngrn(l)
		if(visit(nx(i),ny(i)).eq.1) goto 27
 	   if(nx(i).eq.nx(j).and.ny(i).eq.ny(j)+1) then
	    write(15,*)l,nx(i),ny(i)
		nt(l)=nt(l)+1
		j=i
		visit(nx(i),ny(i))=1
		goto 30
	    endif
	   if(nx(i).eq.nx(j)+1.and.ny(i).eq.ny(j)) then
	    write(15,*)l,nx(i),ny(i)
		nt(l)=nt(l)+1
	    j=i
		visit(nx(i),ny(i))=1
	    goto 30
		endif
27	  enddo

	 do i =1, ngrn(l)
		if(visit(nx(i),ny(i)).eq.1) goto 29
	   if(nx(i).eq.nx(j).and.ny(i).eq.ny(j)-1) then
	    write(15,*)l,nx(i),ny(i)
		nt(l)=nt(l)+1
		j=i
		visit(nx(i),ny(i))=1
		goto 30
	    endif
	   if(nx(i).eq.nx(j)-1.and.ny(i).eq.ny(j)) then
	    write(15,*)l,nx(i),ny(i)
		nt(l)=nt(l)+1
	    j=i
		visit(nx(i),ny(i))=1
		goto 30
		endif
29	  enddo
c****************************************************************
c	Some grid points dont have a neighboring boundary grid belonging 
c	to the same grain. So the next grid is chosen here.
	m1=nx(j)+1
	m2=ny(j)-1
311	if(m1.gt.imax.or.m2.lt.1) goto 301
	if(visit(m1,m2).eq.2) then
	 do lk = 1,ngrn(l)
	  if(nx(lk).eq.m1.and.ny(lk).eq.m2) then
	  j=lk
	  endif
	 enddo
        write(15,*)l,nx(j),ny(j)
		nt(l)=nt(l)+1
	   visit(nx(j),ny(j))=1
	else
	if(visit(m1,m2).ne.2.and.visit(nx(j),m2).eq.1) then
	m2=m2-1
	goto 311
	endif
	endif
301	n1=nx(j)-1
	n2=ny(j)+1
312	if(n1.lt.1.or.n2.gt.jmax) goto 302
	if(visit(n1,n2).eq.2) then
	 do lk = 1,ngrn(l)
	  if(nx(lk).eq.n1.and.ny(lk).eq.n2) then
	  j=lk
	  endif
	 enddo
        write(15,*)l,nx(j),ny(j)
		nt(l)=nt(l)+1
	   visit(nx(j),ny(j))=1
	else
	if(visit(n1,n2).ne.2.and.visit(nx(j),n2).eq.1) then
	   n2=n2+1
	goto 312
	endif
	endif
302	m3=nx(j)-1
	m4=ny(j)-1
313	if(m3.lt.1.or.m4.lt.1) goto 39
	if(visit(m3,m4).eq.2) then
	 do lk = 1,ngrn(l)
	  if(nx(lk).eq.m3.and.ny(lk).eq.m4) then
	  j=lk
	  endif
	 enddo
        write(15,*)l,nx(j),ny(j)
		nt(l)=nt(l)+1
	   visit(nx(j),ny(j))=1
	else
	  if(visit(m3,m4).ne.2.and.visit(m3,ny(j)).eq.1) then
	   m3=m3-1
	  goto 313
 	  endif
	endif
39	    if (m3.eq.0) goto 30
		if(m4.eq.0.and.visit(m3,ny(j)).eq.1) m3=m3-1
	    if (m3.eq.0) goto 30
	    
		if(m4.eq.0.and.visit(m3,ny(j)).ne.1.and.grain(m3,ny(j))
	1	.eq.l) then
	   write(15,*)l,m3,ny(j)
		nt(l)=nt(l)+1
	   visit(m3,ny(j))=1
	   m3=m3-1
	   goto 313
	   endif
30	 enddo
c**************************************************************
c	Output the grid structure.

	write(17,*)l,nt(l)
	do i =1,ngrn(l)
	visit(nx(i),ny(i))=0
	enddo
	enddo
	close(14)
	close(15)
	close(17)
	end subroutine
!**************************************************************
!	NEW SUBROUTINE
!***************************************************************
!	This subroutine counts the number of sides of an individual grain
!*******************************************************************
	subroutine numsides(numgr,mcstep,grain,ncor)
	include 'comblock.f'
	dimension nx(ni*nj*2),ny(ni*nj*2),nt(ni*nj*2),ngr(ni*nj*2),
	1 vis(ni*nj*2),vis1(ni*nj*2)
	integer  side(ni*nj*2),aveneig(ni*nj*2)
	integer grain(ni,nj)
	character*60 filenames
      open(15,file="c:\MC\temp\grnnum.dat")
      open(21,file="c:\MC\temp\side.dat")
	open(17,file="c:\MC\temp\nogrns.dat")
	open(222,file="c:\MC\temp\corners.dat")
	open(2345,file="c:\MC\topol\aveneig.dat")

	ncor = 0
	do l =1,numgr
	nk=0
	nl=0
	side(l)=0.
	 read(17,*)ln,nt(l)
	 do i =1,nt(l)
	 read(15,*)ll,nx(i),ny(i)
	 enddo !do i =1,nt(l)
	numtot=nt(l)
!
	do ll = 1,numgr
	vis(ll) = 0.
	enddo
!
	met1=0
	met2=0
	met3=0
	met4=0
	 do j =1,numtot
	if (nx(j)+1.lt.imax) then
	 if (grain(nx(j),ny(j)).ne.grain(nx(j)+1,ny(j)).and.
     &vis(grain(nx(j)+1,ny(j))).ne.1.) then
	 side(l)=side(l)+1
	 vis(grain(nx(j)+1,ny(j))) = 1.
	write(222,*)l,nx(j),ny(j)
	ncor=ncor+1
	endif
	endif
	if (nx(j).eq.imax.and.met1.ne.1) then
	side(l)= side(l)+1
	met1 = 1
	endif

	if (nx(j)-1.gt.0) then
	 if (grain(nx(j),ny(j)).ne.grain(nx(j)-1,ny(j)).and.
     &vis(grain(nx(j)-1,ny(j))).ne.1.) then
	 side(l)=side(l)+1
	 vis(grain(nx(j)-1,ny(j))) = 1.
	write(222,*)l,nx(j),ny(j)
	ncor=ncor+1
	endif
	endif
	if (nx(j).eq.1.and.met2.ne.1) then 
	side(l)= side(l)+1
	met2 = 1
	endif

	if (ny(j)+1.lt.jmax) then
	 if (grain(nx(j),ny(j)).ne.grain(nx(j),ny(j)+1).and.
     &vis(grain(nx(j),ny(j)+1)).ne.1.) then
	 side(l)=side(l)+1
	 vis(grain(nx(j),ny(j)+1)) = 1.
	write(222,*)l,nx(j),ny(j)
	ncor=ncor+1
	endif
	endif

	if (ny(j).eq.jmax.and.met3.ne.1) then 
	side(l)= side(l)+1
	met3 = 1
	endif

	if (ny(j)-1.gt.0) then
	 if (grain(nx(j),ny(j)).ne.grain(nx(j),ny(j)-1).and.
     &vis(grain(nx(j),ny(j)-1)).ne.1.) then
	 side(l)=side(l)+1
	 vis(grain(nx(j),ny(j)-1)) = 1.
	write(222,*)l,nx(j),ny(j)
	ncor=ncor+1
	endif
	endif
	if (ny(j).eq.1.and.met4.ne.1) then 
	side(l)= side(l)+1
	met4 = 1
	endif

	enddo !do j = 1,numtot
	write (21,*)l, side(l)
	enddo !do l = 1,numgr
	close(21)
	close(222)

	rewind(17)
	rewind(15)
C***************************************
	do l = 1,numgr
		do lm = 1,numgr
		non = 0
		aveneig(lm) = 1
		nt(lm) = 0
		enddo 

	 read(17,*)ln,nt(l)
	 do ii =1,nt(l)
	nx(ii) = 0
	ny(ii) = 0
	enddo
	 do i =1,nt(l)
	 read(15,*)ll,nx(i),ny(i)
	 enddo !do i =1,nt(l)

	do ll = 1,numgr
	vis1(ll) = 0.
	enddo
!
	 do j =1,nt(l)
	nj0 = grain(nx(j),ny(j))



	if (nx(j)+1.lt.imax) then
	nxj1 = grain(nx(j)+1,ny(j))
	 if (nj0.ne.nxj1.and.vis1(nxj1).ne.1.) then
	aveneig(nj0)=aveneig(nj0)+side(nxj1)
	non = non + 1
	 vis1(nxj1) = 1.
	endif
	endif

	if (nx(j)-1.gt.0) then
	nxj0= grain(nx(j)-1,ny(j))
	 if (nj0.ne.nxj0.and.vis1(nxj0).ne.1.) then
	aveneig(nj0)=aveneig(nj0)+side(nxj0)
	non = non + 1
	 vis1(nxj0) = 1.
	endif
	endif

	if (ny(j)+1.lt.jmax) then
	nyj1 = grain(nx(j),ny(j)+1)
	 if (nj0.ne.nyj1.and.vis1(nyj1).ne.1.) then
	aveneig(nj0)=aveneig(nj0)+side(nyj1)
	non = non + 1
	 vis1(nyj1) = 1.
	endif
	endif


	if (ny(j)-1.gt.0) then
	nyj0 = grain(nx(j),ny(j)-1)
	 if (nj0.ne.nyj0.and.vis1(nyj0).ne.1.) then
	aveneig(nj0)=aveneig(nj0)+side(nyj0)
	non = non + 1
	 vis1(nyj0) = 1.
	endif
	endif
	
	enddo !do j =1,nt(l)
	if(non.eq.0) non =1
	write(2345,*)l,side(l),float(aveneig(l))/float(non)
	enddo ! l = 1,numgr
	close(15)
	close(17)
	close(2345)
	close(2346)
	close(2347)
	end subroutine
c**************************************************************
c	NEW SUBROUTINE
c***************************************************************
c	This subroutine calculates the perimeter of individual grains
c*******************************************************************
	subroutine lensides(numgr,ncor)
	include 'comblock.f'
	dimension  alength(ni*nj*2)
	character*60 filenames
      open(222,file="c:\MC\temp\corners.dat")
	open(19,file="c:\MC\temp\perim.dat")
!	Inititalize
	do m= 1, ni*nj*2
	alength(m) = 0.
	enddo
	!***************
	do i =1,ncor
	read(222,*)ll,nx,ny
	if(ll.eq.llold) then
	alen = sqrt((float(nx-nxold)**2)+(float(ny-nyold)**2))
	alength(ll) = alength(ll)+alen
	endif
	llold = ll
	nxold = nx
	nyold = ny
	enddo
	pertot= 0.
	do l = 1,numgr	
	pertot = pertot+alength(l)
	pern = (pertot/2.)*compdat(8)*1.e3
	areat=float(((imax*jmax)+(jmax*kmax)+(kmax*imax))/3)
	areanew = areat*(compdat(8)*1.e3)**2
	enddo
	write(19,*)pern/areanew
	close(222)
	close(19)

	end subroutine
c*********************************************************************
!	Grain Size Distribution Calculation
!*********************************************************************
	subroutine rbyrbar(grain,numgr,mcstep) 
	include 'comblock.f'
	integer grain(ni,nj)
	dimension icount1(ni*nj*2),icount2(ni*nj*2),icount1new(ni*nj*2)
	dimension icount2new(ni*nj*2),R(ni*nj*2), side(ni*nj*2)
	open(53,file="c:\MC\temp\rbyr.dat")
	open(54,file="c:\MC\topol\avgedg.dat")
      open(21,file="c:\MC\temp\side.dat")
	do ll = 1,numgr
	read(21,*)ln,side(ll)
	enddo
	do i =1,imax
	do j=1,jmax
	icount1(grain(i,j)) = 1
	icount1new(grain(i,j)) = 1
	icount2(grain(i,j)) = 1
	icount2new(grain(i,j)) = 1
	enddo
	enddo
        do 105 j=1,jmax
        do 155 i=2,imax
        if (grain(i,j).eq.grain(i-1,j)) icount1(grain(i,j))=icount1
     &(grain(i,j))+1
	if (icount1(grain(i,j)).gt.icount1new(grain(i,j))) then
		icount1new(grain(i,j))= icount1(grain(i,j))
	endif
	
155      continue
	 do i =1,imax
	 icount1(grain(i,j))=1
	 enddo
	
105	continue
       do 106 i=1,imax
        do 156 j=2,jmax
        if (grain(i,j).eq.grain(i,j-1)) icount2(grain(i,j))=icount2
     &(grain(i,j))+1
	if (icount2(grain(i,j)).gt.icount2new(grain(i,j))) then
		icount2new(grain(i,j))= icount2(grain(i,j))
	endif
156      continue
	 do j =1,jmax
	icount2(grain(i,j))=1
	enddo
106      continue
	do l =1,numgr
	R(l) = float(icount1new(l)+icount2new(l))*0.5*compdat(8)*1.e6
	write(53,*)l,R(l),R(l)/average6
	write(54,*)l,side(l),R(l)
	enddo

	close(53)
	close(54)
	close(21)

	end subroutine

